#include "exportData.h"
#include "QtCore\qfile.h"
#include "QtCore\qtextstream.h"
#include <QUrl>
#include <QFile>
#include <QObject>
#include <QByteArray>
#include <QNetworkAccessManager>
#include <string>

Cigarette* cg;
//extern SyncQueue<_ExportDataInfo>* export_Data_Info_queue;
extern SyncQueue<_XMLExportDataInfo>* export_XMLData_Info_queue;
extern ConfPath g_conf_path;

ExportDataThread::ExportDataThread(QObject* parent) : QThread(parent)
{
	cg->read_conf(g_conf_path);
	for (int index = 0; index < NumberOfSupportedCameras; index++)
	{
		XMLError error;
		pDocument[index] = new tinyxml2::XMLDocument();
		QString xmlPath = QString(EXPORTDATA_FILE).arg(index);
		QString filePath = g_conf_path.config_path + "/" + xmlPath;

		error = pDocument[index]->LoadFile(filePath.toLocal8Bit().constData());
		if (error != XML_SUCCESS)
		{
			XMLDeclaration* declaration = pDocument[index]->NewDeclaration();
			pDocument[index]->InsertFirstChild(declaration);
			XMLElement* root = pDocument[0]->NewElement("Root");
			pDocument[0]->InsertEndChild(root);
			pDocument[index]->SaveFile(filePath.toLocal8Bit().constData());
		}
		/*
		_ExportDataInfo data;
		data.cameraId = index;
		data.cameraTotal = 3;
		data.timeCost = "3ms";
		insertXMLNode(xmlPath, data);
		*/

		//_XMLExportDataInfo data;
		//// ܵͳ
		//data.TotalCheckNum = 1000;
		//data.TotalKickNum = 900;
		//data.PassRate = 99.8;
		//data.KickRate = 0.2;
		//// 
		//data.cameraTotal = NumberOfSupportedCameras;
		//data.cameraId = index;
		//data.shotCounts = 3;
		//data.okNum = 560;
		//data.ngNum = 440;
		//data.kickNum = 440;
		//data.AcquisitionSpeed = "3ms";
		//for (int i = 0; i < data.shotCounts; i++)	data.jdNum[i] = 4;
		//data.DetectSpeed = "5ms";
		//insertXMLNode(filePath.toLocal8Bit().constData(), data);
	} 
}

void ExportDataThread::init()
{
	b_quit = false;
}

void ExportDataThread::start_work()
{
	start(HighestPriority);
}

void ExportDataThread::stop()
{
	b_quit = true;
	//_ExportDataInfo data;
	//export_Data_Info_queue->put(data);
	_XMLExportDataInfo data;
	export_XMLData_Info_queue->put(data);
}

bool _ExportDataInfo::getAverageData(map<string, float> &averageData, int index)
{
	tinyxml2::XMLDocument doc;
	//char xmlPath[256];
	XMLError error;
	map<string, float> data;
	//memset(xmlPath, 0, 256);
	QString xmlPath = QString(EXPORTDATA_FILE).arg(index);
	//sprintf(xmlPath, EXPORTDATA_FILE, index);
	QString filePath = g_conf_path.config_path + "/" + xmlPath;
	error = doc.LoadFile(filePath.toLocal8Bit().constData());
	if (error != XML_SUCCESS)
		if (doc.LoadFile(filePath.toLocal8Bit().constData()) != 0)
		{
			cout << "load xml file failed" << endl;
			return false;
		}
	XMLElement* root = doc.RootElement();
	XMLElement* userNode = root->FirstChildElement("Camera");
	data["CameraId"] = index;
	data["IsNG"] = 0;
	data["IsJdExist"] = 0;
	data["Total"] = 0;
	while (userNode != NULL)
	{
		if (atoi(userNode->Attribute("Id")) == index) {
			data["IsNG"]++;
			data["IsJdExist"]++;
			data["Total"]++;
			XMLElement* IsNgNode = userNode->FirstChildElement("IsNG");
			data["IsNg"] = strcmp(IsNgNode->GetText(), "TRUE");
			XMLElement* IsJdExistNode = userNode->FirstChildElement("IsJdExist");
			if (strcmp(IsJdExistNode->GetText(), "TRUE") == 0)
				data["IsJdExist"]++;
			XMLElement* TimeCostNode = userNode->FirstChildElement("TimeCost");
			data["TimeCost"] += stof(TimeCostNode->GetText());
		}
		userNode = userNode->NextSiblingElement();//һֵܽڵ
	}
	if (data["Total"] == 0)
		return false;
	data["TimeCost"] = data["TimeCost"] / data["Total"];

	averageData = data;

	return true;
}

//int ExportDataThread::insertXMLNode(const char* xmlPath, _ExportDataInfo& data)
//{
//	XMLElement* root = pDocument[data.cameraId]->RootElement();
//
//	if (root == NULL) {
//		root = pDocument[data.cameraId]->NewElement("Root");
//		pDocument[data.cameraId]->InsertEndChild(root);
//		pDocument[data.cameraId]->SaveFile(xmlPath);
//	}
//
//	XMLElement* CameraNode = pDocument[data.cameraId]->NewElement("Camera");
//	CameraNode->SetAttribute("Id", data.cameraId);
//	CameraNode->SetAttribute("Count ", data.cameraTotal);
//	root->InsertEndChild(CameraNode);
//
//	XMLElement* IsNG = pDocument[data.cameraId]->NewElement("IsNG");
//	XMLText* IsNGText = pDocument[data.cameraId]->NewText(data.isNg ? "TRUE" : "FALSE");
//	IsNG->InsertEndChild(IsNGText);
//	CameraNode->InsertEndChild(IsNG);
//
//	XMLElement* timeCost = pDocument[data.cameraId]->NewElement("TimeCost");
//	timeCost->InsertEndChild(pDocument[data.cameraId]->NewText(data.timeCost.c_str()));
//	CameraNode->InsertEndChild(timeCost);
//
//	XMLElement* isJdExist = pDocument[data.cameraId]->NewElement("IsJdExist");
//	isJdExist->InsertEndChild(pDocument[data.cameraId]->NewText(data.isJdExist[0] ? "TRUE" : "FALSE"));
//	CameraNode->InsertEndChild(isJdExist);
//
//	// XMLElement* jdInterval = pDocument[data.cameraId]->NewElement("JdInterval");
//	// jdInterval->InsertEndChild(pDocument[data.cameraId]->NewText((const char*)&data.jdInterval));
//	// CameraNode->InsertEndChild(jdInterval);
//
//	// XMLElement* jdInterval = pDocument[data.cameraId]->NewElement("jdPointsLocation");
//	// jdInterval->InsertEndChild(pDocument[data.cameraId]->NewText(data.getPoint(0).c_str()));
//	// CameraNode->InsertEndChild(jdInterval);
//
//	return pDocument[data.cameraId]->SaveFile(xmlPath);
//}

int ExportDataThread::insertXMLNode(const char* xmlPath, _XMLExportDataInfo& data)
{
	XMLElement* root = pDocument[data.cameraId]->RootElement();

	if (root == NULL) {
		root = pDocument[data.cameraId]->NewElement("Root");
		pDocument[data.cameraId]->InsertEndChild(root);
		pDocument[data.cameraId]->SaveFile(xmlPath);
	}

	/// ͳ
	// ܼ
	XMLElement* Total= pDocument[data.cameraId]->NewElement("Total Datas");

	XMLElement* TotalCheckNum = pDocument[data.cameraId]->NewElement("TotalCheckNum");
	char s[20];
	TotalCheckNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.TotalCheckNum, s, 10)));
	Total->InsertEndChild(TotalCheckNum);

	// ޳
	XMLElement* TotalKickNum = pDocument[data.cameraId]->NewElement("TotalKickNum");
	TotalKickNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.TotalKickNum, s, 10)));
	Total->InsertEndChild(TotalKickNum);

	// ϸ
	XMLElement* PassRate = pDocument[data.cameraId]->NewElement("PassRate");
	std::string temp_str = std::to_string(data.PassRate);
	const char* temp_char = temp_str.c_str();
	PassRate->InsertEndChild(pDocument[data.cameraId]->NewText(temp_char));
	Total->InsertEndChild(PassRate);
	
	// ޳
	XMLElement* KickRate = pDocument[data.cameraId]->NewElement("KickRate");
	temp_str = std::to_string(data.KickRate);
	temp_char = temp_str.c_str();
	KickRate->InsertEndChild(pDocument[data.cameraId]->NewText(temp_char));
	Total->InsertEndChild(KickRate);

	root->InsertEndChild(Total);

	/// 
	// id & 
	XMLElement* CameraNode = pDocument[data.cameraId]->NewElement("Camera");
	CameraNode->SetAttribute("Count ", data.cameraTotal);
	CameraNode->SetAttribute("Id", data.cameraId);

	XMLElement* JudgeNum = pDocument[data.cameraId]->NewElement("JudgeNum");
	// ok
	XMLElement* okNum = pDocument[data.cameraId]->NewElement("OkNum");
	okNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.okNum[data.cameraId], s, 10)));
	JudgeNum->InsertEndChild(okNum);
	// ng
	XMLElement* ngNum = pDocument[data.cameraId]->NewElement("NgNum");
	ngNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.ngNum[data.cameraId], s, 10)));
	JudgeNum->InsertEndChild(ngNum);
	// ʵ޳ͨ޳ʱΪ޳
	XMLElement* kickNum = pDocument[data.cameraId]->NewElement("KickNum");
	kickNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.kickNum[data.cameraId], s, 10)));
	JudgeNum->InsertEndChild(kickNum);

	// ʶ
	XMLElement* JdNum = pDocument[data.cameraId]->NewElement("JdNum");
	JdNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.shotCounts, s, 10)));
	for (int j = 0; j < data.shotCounts; j++)
		JdNum->InsertEndChild(pDocument[data.cameraId]->NewText(itoa(data.jdNum[j], s, 10)));
	JudgeNum->InsertEndChild(JdNum);

	CameraNode->InsertEndChild(JudgeNum);

	// ɼٶ
	XMLElement* speed = pDocument[data.cameraId]->NewElement("Speed");

	XMLElement* AcquisitionSpeed = pDocument[data.cameraId]->NewElement("AcquisitionSpeed");
	AcquisitionSpeed->InsertEndChild(pDocument[data.cameraId]->NewText(data.AcquisitionSpeed.c_str()));
	speed->InsertEndChild(AcquisitionSpeed);
	// ٶ
	XMLElement* DetectSpeed = pDocument[data.cameraId]->NewElement("DetectSpeed");
	DetectSpeed->InsertEndChild(pDocument[data.cameraId]->NewText(data.DetectSpeed.c_str()));
	speed->InsertEndChild(DetectSpeed);
	CameraNode->InsertEndChild(speed);

	root->InsertEndChild(CameraNode);

	return pDocument[data.cameraId]->SaveFile(xmlPath);
}

void ExportDataThread::run()
{
	while (!b_quit) {
		//_ExportDataInfo element;
		//export_Data_Info_queue->take(element);
		_XMLExportDataInfo element;
		export_XMLData_Info_queue->take(element);
		if (element.cameraId != -1) {
			char buf[256];
			memset(buf, 0, 256);
			QString xmlPath = QString(EXPORTDATA_FILE).arg(element.cameraId);
			QString filePath = g_conf_path.config_path + "/" + xmlPath;
			sprintf(buf, filePath.toLocal8Bit().constData(), element.cameraId);
			insertXMLNode(buf, element);

			//
			// Ftp transfer demo
			//
			QNetworkAccessManager manager;
			QUrl url;
			/* ͨѶЭ */
			url.setScheme("ftp");
			/* û */
			url.setUserName("xxx");
			/*  */
			url.setPassword("xxxxxx");
			/* Ҳ */
			url.setHost("127.0.0.1");
			/* ö˿ںţһΪ21 */
			url.setPort(21);
			/* · */
			url.setPath("/tmp/" + xmlPath);

			/* װرļ */
			QFile file(filePath);
			file.open(QIODevice::ReadOnly);
			/* ȡļ */
			QByteArray data = file.readAll();
			file.close();

			QNetworkRequest request(url);
			/* ϴݣϴɹԶ˴/tmp/hello.pngļ */
			QNetworkReply* reply = manager.put(request, data);

			//QEventLoop eventLoop;
			//QObject::connect(reply, SIGNAL(finished()), &eventLoop, SLOT(quit()));
			/* ȴ¼ѭȻ */
			//eventLoop.exec();

			//if (reply->error() != QNetworkReply::NoError) {
			//	qDebug() << "Error: " << reply->errorString();
			//}
		}
	}

	for (int index = 0; index < NumberOfSupportedCameras; index++) {
		pDocument[index]->~XMLDocument();
	}
	
}

void ExportDataThread::check_save_dir(std::string dir_path)
{
	bool b_find = false;
	for (int i = 0; i < vec_save_dirs.size(); i++)
	{
		if (dir_path == vec_save_dirs[i])
		{
			b_find = true;
		}
	}
	if (!b_find)
	{
		//QString dir_str = QString::fromStdString(dir_path);
		QString dir_str = QString::fromLocal8Bit(QByteArray::fromRawData(dir_path.c_str(), dir_path.size()));

		QDir dir;
		if (!dir.exists(dir_str))
		{
			dir.mkpath(dir_str);
		}
		vec_save_dirs.push_back(dir_path);
	}
}